#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sam.h"

void readBedFile(char* filename, char *outfilename) ;
void readBAMFile(char* filename, char *outfilename) ;
void readBedGraphFile(char* filename, char *outfilename);

main(int argc, char **argv)
{
int format ;
format = 1 ;
if(argc < 2) {printf("\n Usage: findlimits  tagfile genome-limit format \n") ; exit(1) ;}
if(argc > 2) { format = atoi(argv[3]) ; }

if(format == 1){ readBedFile( argv[1], argv[2]) ; }
if(format == 2) { readBAMFile( argv[1], argv[2]) ; }
if(format == 3) { readBedGraphFile(argv[1], argv[2]); }
}



void readBedFile(char* filename, char *outfilename)
{
    FILE *infile, *ofile ;
int i, j, line ,chrloc, totalbins, **chrinfo,chridx ;
long maxloc , minloc;
char instr[120], tempstr[100], prevchr[100], currchr[100], **chromosomes ;
int *locarray , *chrarray, count ;
float *data ;

maxloc = 0 ;
minloc = 10000000000 ;

chromosomes = (char**)malloc(10000 * sizeof(char*)) ;
chrinfo = (int**)malloc(10000 * sizeof(int*)) ;
for (i = 0 ; i < 10000; i++)
{
chromosomes[i] = (char*)malloc(100*sizeof(char)) ;
chrinfo[i] = (int*)malloc(2*sizeof(int)) ;
}

for(i = 0 ; i < 10000 ; i++)
{
chrinfo[i][0] = minloc ; chrinfo[i][1] = maxloc ;
}

sprintf( prevchr, "chr0") ; 

printf("going to load file") ; // scanf("%s" , tempstr) ;

infile = fopen(filename, "r") ;

line = 0 ;
count = 0 ;
totalbins = 0 ;

// printf("loaded file") ;  scanf("%s" , tempstr) ;

chridx= 0 ;
while(!feof(infile))
{
line = line + 1 ;
fscanf(infile, "%s", currchr) ;
if(!feof(infile)) {
fscanf(infile, "%s", instr) ; chrloc = atoi(instr) ;
fscanf(infile, "%s", instr) ;
fscanf(infile, "%s", instr) ;
fscanf(infile, "%s", instr) ;
fscanf(infile, "%s" , instr) ;


/*
printf("%s %d %d %d\n", currchr, line, minloc, maxloc ) ;
*/

if(strcmp(currchr , prevchr) != 0)
{
chridx = count ;
for(i = 0 ; i < count ; i++)
{
if(strcmp(currchr, chromosomes[i]) == 0) { chridx = i ; }
}
if(chrinfo[chridx][0] > chrloc) {  chrinfo[chridx][0] = chrloc ; }
if(chrinfo[chridx][1] < chrloc) {  chrinfo[chridx][1] = chrloc ; }
//printf("%s %d %d %d\n", prevchr, line, minloc, maxloc ) ;

maxloc = 0 ;
minloc = 10000000000 ;

//totalbins = totalbins + (maxloc - minloc) / 200 ;

if(chridx == count) 
{
strcpy( chromosomes[count], currchr) ;
count = count + 1 ;
if(count > 9999) { printf("\n\n\n Probabaly new genome : Number of contigs more than 999 \n exiting \n") ; exit(1) ; }
}
strcpy(prevchr,  currchr) ;
}
else
{
if(chrinfo[chridx][0] > chrloc) {  chrinfo[chridx][0] = chrloc ; }
if(chrinfo[chridx][1] < chrloc) {  chrinfo[chridx][1] = chrloc ; }
}
}
}

ofile = fopen( outfilename, "w") ;

for(i = 0 ; i < count ; i++)
{
if(chrinfo[i][1]  > 200) 
{
if(chrinfo[i][0]  < 1) { chrinfo[i][0]  =  1 ;}
chrinfo[i][1] = chrinfo[i][1] -100 ;
fprintf(ofile, "%s %d %d\n", chromosomes[i], chrinfo[i][0] , chrinfo[i][1] ) ; 
}
}
fclose(ofile) ;
}





void readBAMFile(char* filename, char *outfilename)
{
     FILE *infile, *ofile ;
    int i, **chrinfo, chrloc,   count, chridx ;
    char **chromosomes ;
  
chromosomes = (char**)malloc(10000 * sizeof(char*)) ;
chrinfo = (int**)malloc(10000 * sizeof(int*)) ;
for (i = 0 ; i < 10000 ; i++)
{
chromosomes[i] = (char*)malloc(100*sizeof(char)) ;
chrinfo[i] = (int*)malloc(2*sizeof(int)) ;
}


  printf("\n DFilter: reading %s \n" ,filename );
  
  samfile_t *fp;
  if ((fp = samopen(filename, "rb", 0)) == 0) 
  {
 printf("\nDFilter: could not open file %s ", filename );
    exit(1);
  }

  
  count = fp->header->n_targets;
  for ( i = 0; i < count ; i++)
  {
  char *currchr = fp->header->target_name[i];
  chrinfo[i][0] = 1000000000 ; chrinfo[i][1] = 0 ; 
  strcpy( chromosomes[i], currchr) ;
  }

  
  
  bam1_t *b = bam_init1();
  while (samread(fp, b) >= 0)
  {
    const bam1_core_t *c = &b->core;
    if (c->tid != -1)
    {
    chridx = c->tid ;
      if (c->flag & BAM_FREVERSE) { chrloc = bam_calend(c, bam1_cigar(b)) ;}
            else {    chrloc  =   c->pos; }
  if(chrinfo[chridx][0] > chrloc) {  chrinfo[chridx][0] = chrloc ; }
if(chrinfo[chridx][1] < chrloc) {  chrinfo[chridx][1] = chrloc ; }
      
  }
  }
    bam_destroy1(b);
  
  samclose(fp);


ofile = fopen(outfilename, "w") ;

for(i = 0 ; i < count ; i++)
{
 if(chrinfo[i][1]  > 200) 
{
if(chrinfo[i][0]  < 1) { chrinfo[i][0]  =  1 ;}
chrinfo[i][1] = chrinfo[i][1] -100 ;
fprintf(ofile, "%s %d %d\n", chromosomes[i], chrinfo[i][0] , chrinfo[i][1] ) ; 
}
}
fclose(ofile) ;
  
}





void readBedGraphFile(char* filename, char *outfilename)
{
    FILE *infile, *ofile ;
int i, j, line ,chrloc, totalbins, **chrinfo,chridx ;
long maxloc , minloc;
char instr[120], tempstr[100], prevchr[100], currchr[100], **chromosomes  ;
int *locarray , *chrarray, count ;
float *data ;

maxloc = 0 ;
minloc = 10000000000 ;

chromosomes = (char**)malloc(10000 * sizeof(char*)) ;
chrinfo = (int**)malloc(10000 * sizeof(int*)) ;
for (i = 0 ; i < 10000 ; i++)
{
chromosomes[i] = (char*)malloc(100*sizeof(char)) ;
chrinfo[i] = (int*)malloc(2*sizeof(int)) ;
}

for(i = 0 ; i < 10000 ; i++)
{
chrinfo[i][0] = minloc ; chrinfo[i][1] = maxloc ;
}

sprintf( prevchr, "chr0") ; 

printf("going to load file") ; // scanf("%s" , tempstr) ;

infile = fopen(filename, "r") ;

line = 0 ;
count = 0 ;
totalbins = 0 ;

// printf("loaded file") ;  scanf("%s" , tempstr) ;

chridx= 0 ;
while(!feof(infile))
{
line = line + 1 ;
fscanf(infile, "%s", currchr) ;
if(!feof(infile)) {
fscanf(infile, "%s", instr) ; chrloc = atoi(instr) ;
fscanf(infile, "%s", instr) ;
fscanf(infile, "%s", instr) ;

/*
printf("%s %d %d %d\n", currchr, line, minloc, maxloc ) ;
*/

if(strcmp(currchr , prevchr) != 0)
{
chridx = count ;
for(i = 0 ; i < count ; i++)
{
if(strcmp(currchr, chromosomes[i]) == 0) { chridx = i ; }
}
if(chrinfo[chridx][0] > chrloc) {  chrinfo[chridx][0] = chrloc ; }
if(chrinfo[chridx][1] < chrloc) {  chrinfo[chridx][1] = chrloc ; }
//printf("%s %d %d %d\n", prevchr, line, minloc, maxloc ) ;

maxloc = 0 ;
minloc = 10000000000 ;

//totalbins = totalbins + (maxloc - minloc) / 200 ;

if(chridx == count) 
{
strcpy( chromosomes[count], currchr) ;
count = count + 1 ;
if(count > 9999) { printf("\n\n\n Probabaly new genome : Number of contigs more than 9999 \n exiting \n") ; exit(1) ; }
}
strcpy(prevchr,  currchr) ;
}
else
{
if(chrinfo[chridx][0] > chrloc) {  chrinfo[chridx][0] = chrloc ; }
if(chrinfo[chridx][1] < chrloc) {  chrinfo[chridx][1] = chrloc ; }
}
}
}

ofile = fopen( outfilename, "w") ;

for(i = 0 ; i < count ; i++)
{
if(chrinfo[i][1]  > 200) 
{
if(chrinfo[i][0]  < 1) { chrinfo[i][0]  =  1 ;}
chrinfo[i][1] = chrinfo[i][1] -100 ;
fprintf(ofile, "%s %d %d\n", chromosomes[i], chrinfo[i][0] , chrinfo[i][1]) ; 
}
}
fclose(ofile) ;
}








