function predictexpr( ChIPfiles, ChIPnum, geneFile, matrixFile , outfile )
wsize = 200 ;
binsize = wsize ;

chrX = 'chr23' ; chrY = 'chr24' ; chrM = 'chr25' ;

genomeinfo = loadbed('genome-limits') ;
[chromcount cols] = size(genomeinfo) ;

chromMap = [] ; locs = 0 ;
for i =1:chromcount
chrominfo(i, 1) = genomeinfo(i, 1) ;
chromMap(genomeinfo(i, 1), 1) = i ;
chrominfo(i, 2) = locs + 1 ;
chrominfo(i, 3) = genomeinfo(i, 2) ;
locs = locs + ( genomeinfo(i, 3) - genomeinfo(i, 2)) / binsize ;
chrominfo(i, 4) = locs ; 
chrominfo(i, 5) = genomeinfo(i, 3) ;
end

chrominfo = ceil(chrominfo) ;
totalbins = chrominfo(chromcount, 4) ;

[crows ccols] = size(ChIPnum) ;

[ NMlist chrom sign cdst cdend gname  ] = textread(geneFile , '%s\t%s\t%s\t%d\t%d\t%s') ;

[grows gcols] = size(cdst) ;
genedata = zeros(grows, 4) ;

for i = 1:grows
    chrname = chrom{i} ;
 if(strcmp(chrname , 'chrX') == 1)  
     chrname = chrX ;  
 end
 if(strcmp(chrname , 'chrY') == 1) 
     chrname = chrY ;
 end
 if(strcmp(chrname , 'chrM') == 1) 
     chrname = chrM ;
 end
    chr  = textscan( chrname, '%s %d', 'delimiter' , 'r') ;
    
genedata(i , 1) = chr{2} ; genedata(i, 2) = cdst(i) ; genedata(i, 3) = cdend(i) ;

if(strcmp(sign{i}, '+'))
genedata(i, 4) = 1 ;
else
    genedata(i, 4) = -1 ;
end

end

prommat = bin2mat(genedata(:, 1:3) ,  chrominfo, chromMap, wsize) ;

for i = 1:ccols
  command = sprintf('/home/kumarv1/Histone-modification/PLos/matlab/tag2mat  %s tmp.txt' ,ChIPfiles{i} ) ;
  system(command) ;
  tmpdata = loadtags('tmp.txt', 1) ;
datamod(:, i) = bintags(tmpdata, 2 , chrominfo, chromMap, wsize) ;    
end

 scoremat = load(matrixFile) ;
 [rows sccols] = size(scoremat) ;
    [genes cols] = size(genedata) ;
   
    expr = [] ; 
    
    keeppos =  zeros(genes, 1 ) ;
    exprdata = zeros(genes, sccols ) ;
    lcollect = zeros(genes, 31) ;
    avgprom = zeros(genes, 1) ;
     
  [ rows  dcols ] = size(datamod) ; 
  
         for mark = 1:dcols
       count = 0 ;
             for i = 1:genes      
         minj = prommat(i,1) ; maxj = prommat(i, 2) ;
        
         if (genedata(i, 4) == 1)
         prominj = minj - 10 ; promaxj = minj + 20 ;
           if ((prominj > 0) & (promaxj < rows))
          count = count + 1 ;
          lcollect(count , :) = datamod(prominj:promaxj, 1) ; 
         exprdata(count , :) = scoremat(i , :) ;  
         keeppos(i) = 1 ;
           end
         else
             prominj = maxj - 20 ; promaxj = maxj + 10 ;
        if ((prominj > 0) & (promaxj < rows))
          count = count + 1 ;
        ctemp = datamod(prominj:promaxj, 1) ;
       lcollect(count , :) = ctemp((32 -(1:31))) ;
           exprdata(count , :) = scoremat(i , :)   ;  
           keeppos(i) = 1 ;
        end
        
         end
            
             end
             
       pcollect{mark} = lcollect(1:count,:) ;
       pavgprom(:,mark) = mean(lcollect(1:count,:), 2) ;
         end
         
         
         if(count < genes)
             exprdata(count+1:genes,:) = [] ;
         end
size(exprdata) 
size(pavgprom)
        
         
for i = 1:6
    tgdata = exprdata(:, 7*(i-1) + 1 : 7*i) ; 
expr(:, i) = tgdata(:, 1) ; 
resid(:, i) = tgdata(:, 2) ;
tavgprom{i} = tgdata(:, (2+ChIPnum)) ;
end


for i = 1:6
    for j = 1:dcols
        ccrel(i, j) = corr(pavgprom(:, j) , tavgprom{i}(:, j) );
    end
[mi ridx ] = max( mean(ccrel)) ;
    [ cer cidx ] = sort( ccrel( ridx, :) , 'descend') ;
end

ridx 
cidx 

% allc1 = allcol{tra} ;
% allc2 = allcol{lea} ;
% exprt = allexpr{tra} ;
% exprl = allexpr{lea} ;
% marks = 1:4 ; marks(lea) = [] ;
% %resid =  [ allresid{marks(1)} allresid{marks(2)} allresid{marks(3)} ];
% %resid =  [ allresid{marks(1)} allresid{marks(2)} ] ;
%      resid = allresid{tra} ;

%%%% find Rank invariant genes
 
data =  tavgprom{ridx}(:, cidx(1)) ; [B idx] = sort( data ) ; rdata1(idx, 1) = 1:count ;
data =   tavgprom{ridx}(:, cidx(2)) ; [B idx] = sort( data) ; rdata1(idx, 2) = 1:count ;
    

data = mean(pcollect{cidx(1)} , 2) ; [B idx] = sort(data ) ; rdata2(idx, 1) = 1:count ;
 data = mean(pcollect{cidx(2)} , 2) ; [B idx] = sort( data) ; rdata2(idx, 2) = 1:count ;

     pos = find(( abs(rdata1(:, 1) - rdata2(:, 1)) < 2000 ) & ( abs(rdata1(:, 2) - rdata2(:, 2)) < 2000 ) ) ;
    
    [rog cog] = size(pos) ;
    
    Y = expr(pos , ridx)  ;
    X = pcollect{1}  ; 
    
    for i = 2:ccols
    X = [ X pcollect{i} ] ;
    end
    
    X =  log( X + 1)  ;

    X = [ 3*resid X ] ; 
    Xt = X(pos,:) ;
    newcov = optimiseCov(Xt' * Xt , 2, rog) ; beta = Y' * Xt * inv(newcov) ; Yp = beta * X'  ; Yp = Yp' ;
   

corr(Yp, expr(:,ridx))

kpos = find(keeppos == 1) ;

fid = fopen( outfile, 'w') ;
for i = 1:count
fprintf(fid, '%s\t%s\t%s\t%d\t%d\t%s\t%f\n' , NMlist{kpos(i)}, chrom{kpos(i)}, sign{kpos(i)}, cdst(kpos(i)), cdend(kpos(i)), gname{kpos(i)}, Yp(i) ) ;
end
fclose(fid) ;




%%%%%%%%%%%%%
%  1-H3K27ac , 2-H4K20m1, 3-H3K4me3, 4-H3K36me3, 5-H3K9ac
%
%
%
%    
























         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         
         






























