#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sam.h"

void readBedFile(char* filename, char *outfilename, char *limitsf) ;
void readBAMFile(char* filename, char *outfilename, char *limitsf, int PE ) ;

main(int argc, char **argv)
{

int format , PE;
PE = 0 ; format = 1 ;
if(argc < 4) {  printf(" USAGE: \n tag2mat input.tag output.txt  genome-limitf  format  PE1_SR0_int \n ") ;  exit(1) ; }

if(argc > 5)
{
PE = atoi(argv[5]) ;
}
if(argc > 4) { format = atoi(argv[4]) ; }

if(format == 1){ readBedFile( argv[1], argv[2], argv[3] ) ; }
if(format == 2) { readBAMFile( argv[1], argv[2] , argv[3], PE ) ; }
if(format == 3) { readBedGraphFile( argv[1], argv[2] , argv[3] ) ; }

}



void readBedFile(char* filename, char *outfilename, char *limitsf)
{
FILE *infile, *infile1 , *ofile ;
int i , j , lines, chrloc1, chrloc2, signInt, currchr, count, pchr;
char instr[120] , **chromosomes , prev[120] ;

chromosomes = (char**)malloc(10000 * sizeof(char*)) ;
for (i = 0 ; i < 10000; i++)
{
chromosomes[i] = (char*)malloc(100*sizeof(char)) ;
}



infile = fopen( filename, "r") ;
ofile = fopen( outfilename, "w") ;

infile1 = fopen(limitsf , "r") ;
fscanf(infile1 , "%s" , instr) ;
count = 1 ;
while(!feof(infile1)) 
{
strcpy(chromosomes[count], instr) ;
printf("%s %d\n" , chromosomes[count], count) ;
count = count + 1 ;   
  fscanf(infile1 , "%s" , instr) ;
  fscanf(infile1 , "%s" , instr) ;
  fscanf(infile1 , "%s" , instr) ;
}
fclose(infile1) ;

strcpy(prev, "chr0" ) ;

fscanf(infile, "%s" , instr) ;

while(!feof(infile))
{
    if(strcmp(instr , prev) != 0)
    {
        currchr = 0 ;
       for(i = 1 ; i < count ; i++) 
           { 
            if(strcmp(instr , chromosomes[i]) == 0) { currchr = i ; break ; } 
           }
    strcpy(prev , instr) ;
    }
        
       
fscanf(infile, "%s" , instr) ; chrloc1 = atoi(instr) ;
fscanf(infile, "%s" , instr) ; chrloc2 = atoi(instr) ;
fscanf(infile, "%s" , instr) ;
fscanf(infile, "%s" , instr) ;
fscanf(infile, "%s" , instr) ;
 
if( instr[0]  == '+')  { signInt = 1 ;   } 
else { signInt = -1 ;   chrloc1 = chrloc2;   }
if(currchr > 0) {  fprintf(ofile, "%d %d %d\n" , currchr, chrloc1, signInt ) ; }
fscanf(infile, "%s" , instr) ;
}

fclose(ofile) ;

}






void readBAMFile(char* filename, char *outfilename, char *limitsf, int PE )
{
FILE   *infile1 , *ofile ;
int i , j , lines, chrloc1, chrloc, signInt,  signInt1, count, pchr, idmap[1000] ;
int chridx, chridx1 ;
char instr[120] , **chromosomes , prev[120] ;

chromosomes = (char**)malloc(10000 * sizeof(char*)) ;
for (i = 0 ; i < 10000; i++)
{
chromosomes[i] = (char*)malloc(100*sizeof(char)) ;
}


ofile = fopen( outfilename, "w") ;

infile1 = fopen(limitsf , "r") ;
fscanf(infile1 , "%s" , instr) ;
count = 1 ;
while(!feof(infile1)) 
{
strcpy(chromosomes[count], instr) ;
printf("%s %d\n" , chromosomes[count], count) ;
count = count + 1 ;   
  fscanf(infile1 , "%s" , instr) ;
  fscanf(infile1 , "%s" , instr) ;
  fscanf(infile1 , "%s" , instr) ;
}
fclose(infile1) ;


  printf("\n DFilter: reading %s \n" ,filename );
  
  samfile_t *fp;
  if ((fp = samopen(filename, "rb", 0)) == 0) 
  {
 printf("\nDFilter: could not open file %s ", filename );
    exit(1);
  }

 
  
  for ( i = 0; i <  fp->header->n_targets ;  i++)
  {
  char *currchr = fp->header->target_name[i]; 
  for (j = 0 ; j < count ; j++) { 
  if( strcmp ( chromosomes[j], currchr)  == 0 )
  {
  idmap[i] = j ;
  break ;
  } 
  }
}

if (PE == 1)
{
bam1_t *b = bam_init1();
bam1_t *b1 = bam_init1();

while (samread(fp, b) >= 0)
 {
if(BAM_FPROPER_PAIR)
{
samread(fp, b1) ;
const bam1_core_t *c = &b->core;
const bam1_core_t *c1 = &b1->core;

    if ( (c->tid != -1) & (c1->tid != -1))
    {
    chridx = idmap[c->tid] ;
      if (c->flag & BAM_FREVERSE) { chrloc = bam_calend(c, bam1_cigar(b)) ;  signInt = -1 ;}
            else {    chrloc  =   c->pos;  signInt = 1 ;  }

    chridx1 = idmap[c1->tid] ;
      if (c1->flag & BAM_FREVERSE) { chrloc1 = bam_calend(c1 , bam1_cigar(b1)) ;  signInt1 = -1 ;}
            else {    chrloc1  =   c1->pos;  signInt1 = 1 ;  }
if( ((signInt * signInt1)  == -1) & (chridx == chridx1) )
{
 fprintf(ofile, "%d %d %d\n" , chridx , chrloc, chrloc1 ) ; 
   }
}} }
  bam_destroy1(b);
    bam_destroy1(b1);
  
}

else
{
bam1_t *b = bam_init1();
 
  while (samread(fp, b) >= 0)
  {
    const bam1_core_t *c = &b->core;
    if (c->tid != -1)
    {
    chridx = idmap[c->tid] ;
      if (c->flag & BAM_FREVERSE) { chrloc = bam_calend(c, bam1_cigar(b)) ;  signInt = -1 ;}
            else {    chrloc  =   c->pos;  signInt = 1 ;  }
     fprintf(ofile, "%d %d %d\n" , chridx, chrloc, signInt ) ; 
     }     
  }  
   bam_destroy1(b);
}
  
  
  samclose(fp);
fclose(ofile) ;
}




readBedGraphFile(char* filename, char *outfilename, char *limitsf)
{
  FILE *infile, *infile1 , *ofile ;
int i , j , lines, chrloc1, chrloc2, signInt, currchr, count, pchr;
char instr[120] , **chromosomes , prev[120] ;
float score ;

chromosomes = (char**)malloc(10000 * sizeof(char*)) ;
for (i = 0 ; i < 10000; i++)
{
chromosomes[i] = (char*)malloc(100*sizeof(char)) ;
}



infile = fopen( filename, "r") ;
ofile = fopen( outfilename, "w") ;

infile1 = fopen(limitsf , "r") ;
fscanf(infile1 , "%s" , instr) ;
count = 1 ;
while(!feof(infile1)) 
{
strcpy(chromosomes[count], instr) ;
printf("%s %d\n" , chromosomes[count], count) ;
count = count + 1 ;   
  fscanf(infile1 , "%s" , instr) ;
  fscanf(infile1 , "%s" , instr) ;
  fscanf(infile1 , "%s" , instr) ;
}
fclose(infile1) ;

strcpy(prev, "chr0" ) ;

fscanf(infile, "%s" , instr) ;

while(!feof(infile))
{
    if(strcmp(instr , prev) != 0)
    {
        currchr = 0 ;
       for(i = 1 ; i < count ; i++) 
           { 
            if(strcmp(instr , chromosomes[i]) == 0) { currchr = i ; break ; } 
           }
    strcpy(prev , instr) ;
    }
        
       
fscanf(infile, "%s" , instr) ; chrloc1 = atoi(instr) ;
fscanf(infile, "%s" , instr) ; chrloc2 = atoi(instr) ;
fscanf(infile, "%s" , instr) ;  score = atof(instr) ;
if(currchr > 0) {  fprintf(ofile, "%d %d %f\n" , currchr, chrloc1, score ) ; }
fscanf(infile, "%s" , instr) ;
}

fclose(ofile) ;
      
}

